/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Oct.07.1999  Programing start
  Mar.05.2000  GdkPixbuf Version.

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ
  ChangeFace       -- ɽ̤Υ鳨򺹤ؤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- եåǡ */
#include  "../picture/lm_penguin.xpm"

/* --- ɽ */
gchar  mth[12][4] = {
  "Jan", "Feb", "Mar", "Apr",
  "May", "Jun", "Jul", "Aug",
  "Sep", "Oct", "Nov", "Dec",
};


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  disp_time(void);
void  update_graphic(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

gint  timer;

/* --- ɽ륭饯 */
GdkPixmap *pic;

/* --- ִ */
time_t  tg;
struct tm       *ltime;

/* --- եå */
gint  fw, fh, fs;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  timer = 0;
  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-26-*-*-*-*-*-*-*,\
            -misc-fixed-medium-*-normal-*-24-*-*-*-*-*-jisx0208.1983-0");

  /* -- եå pixmap  */
  pic = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
				     NULL,
				     NULL,
				     lm_penguin_xpm);
  tg = time(NULL);

  /* -- ǥեȥեå */
  RRScreenPutPixmap(pic, 0, 0);
  disp_time();

  /* -- GdkRGB ν */
  gdk_rgb_init();

}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (pic != NULL) gdk_pixmap_unref(pic);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  if (tg != time(NULL)) {
    tg = time(NULL);
    update_graphic();
  }

  return 1;
}




/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
  fs = 0;
  if (fw < 200) {
    fw = 200;
    fs = 1;
  }
  if (fh < 100) {
    fh = 100;
    fs = 1;
  }
}




/* -------------------------------------------------------------
  RRMainWindowClean   -- ̽񤭴

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowClean(void)
{
  RRScreenClear(0, 0, 0);
  RRScreenPutPixmap(pic, 0, 0);
}



/* -------------------------------------------------------------
  ChangeFace       -- ɽ̤Υ鳨򺹤ؤ

   return : void
   gint  ɽ륭饯Υե̾
-------------------------------------------------------------- */
void       ChangeFace(gchar *fname)
{
  GdkPixbuf *chr;
  GdkGC     *gc;
  gint  w, h;

  chr = gdk_pixbuf_new_from_file(fname);
  if (chr != NULL) {
    w = gdk_pixbuf_get_width(chr);
    h = gdk_pixbuf_get_height(chr);
    RRMainWindowSize(w, h);
    RRScreenFree();
    gtk_widget_set_usize (RRScreenWindow(), fw, fh);
    RRScreenInit(RRScreenWindow(), RRScreenCanvas(), fw, fh, TRUE);
    if (pic != NULL) gdk_pixmap_unref(pic);

    pic = gdk_pixmap_new(RRScreenCanvas()->window, w, h, -1);
    gc = gdk_gc_new(pic);
    gdk_pixbuf_render_to_drawable(chr, pic, gc,
				  0, 0, 0, 0, w, h,
				  GDK_RGB_DITHER_NONE, 0, 0);
    RRScreenPutPixmap(pic, 0, 0);
    disp_time();
    gdk_gc_destroy(gc);
    gdk_pixbuf_unref(chr);
  }
}



/* -------------------------------------------------------------
  disp_time       -- ߻񤭹
-------------------------------------------------------------- */
void  disp_time(void)
{
  GtkWidget  *win;
  struct tm *timedata;
  gchar  date[64], time[64];

  timedata = localtime(&tg);
  sprintf(date, "%s.%02d.%4d", mth[timedata->tm_mon],
	  timedata->tm_mday, timedata->tm_year+1900);
  sprintf(time, "%02d:%02d:%02d", timedata->tm_hour,
	  timedata->tm_min, timedata->tm_sec);

  win = RRScreenCanvas();
  RRScreenGCColor(0, 0, 0);
  RRScreenFontLocate(fw-190-1, fh-70);
  RRScreenFontPrint(date);
  RRScreenFontLocate(fw-110-1, fh-40);
  RRScreenFontPrint(time);
  RRScreenFontLocate(fw-190+1, fh-70);
  RRScreenFontPrint(date);
  RRScreenFontLocate(fw-110+1, fh-40);
  RRScreenFontPrint(time);
  RRScreenFontLocate(fw-190, fh-70-1);
  RRScreenFontPrint(date);
  RRScreenFontLocate(fw-110, fh-40-1);
  RRScreenFontPrint(time);
  RRScreenFontLocate(fw-190, fh-70+1);
  RRScreenFontPrint(date);
  RRScreenFontLocate(fw-110, fh-40+1);
  RRScreenFontPrint(time);
  RRScreenGCColor(0xe000, 0xe000, 0xf800);
  RRScreenFontLocate(fw-190, fh-70);
  RRScreenFontPrint(date);
  RRScreenFontLocate(fw-110, fh-40);
  RRScreenFontPrint(time);
}


/* -------------------------------------------------------------
  update_graphic  -- ʸɽΰɤĤ֤
-------------------------------------------------------------- */
void  update_graphic(void)
{
  GdkPixmap *screen_buf;

  /* --- տŪ˥ꥢ򤫤ޤ */
  if (fs == 1) RRScreenClear(0, 0, 0);

  screen_buf = RRScreenBuffer();
  gdk_gc_set_clip_mask(RRScreenGCGet(), NULL);
  gdk_gc_set_clip_origin(RRScreenGCGet(), fw-200, fh-100);
  gdk_draw_pixmap(screen_buf, RRScreenGCGet(), pic, fw-200, fh-100,
		  fw-200, fh-100, fw, 100);
  disp_time();
}


