/* =====================================================================

   LiMo - Liblary
      Command line switch.  - ޥɥ饤󥹥åɤ߼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Dec.14.1999  Programing start
  Dec.29.1999  -root add
  Mar.05.2000  for limo_clock

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRSwitch             -- åϽ
  RRSwitchGetHelp      -- helpåɤ߼
  RRSwitchGetGeometry  -- ȥǡϤ
  RRSwitchGetRoot      -- 롼ȥåϤ
  RRSwitchGetPicture   -- եåλ

  switch_geometry  -- ȥꥳޥɤβ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "rr_switch.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  help_output(void);
void  switch_geometry(char *);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

static  gint  geometry_w = 0, geometry_h = 0;
static  gint  geometry_x = 0, geometry_y = 0;
static  gboolean  geometry_flag;
static  gboolean  root_flag;
static  gboolean  help_flag;
static  gchar     *picture_file;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRSwitch            -- åϽ

   return : void
   int argc, char *argv[]

-------------------------------------------------------------- */
void RRSwitch(int argc, char *argv[])
{
  int rest, i;

  /* ---  */
  geometry_flag = root_flag = help_flag = FALSE;
  picture_file = NULL;

  rest = argc - 1;
  i = 1;
  while(rest > 0) {
    /* --- إץå */
    if ((strcmp(argv[i], "-h") == 0) ||
	(strcmp(argv[i], "--help") == 0)) {
      help_flag = TRUE;
    }
    /* --- geometry  */
    if (((strcmp(argv[i], "-geometry") == 0) ||
	(strcmp(argv[i], "--geometry") == 0)) && (rest > 1)) {
      switch_geometry(argv[i+1]);
      geometry_flag = TRUE;
      i++;
      rest--;
    }
    /* --- root å */
    if (strcmp(argv[i], "-root") == 0) {
      root_flag = TRUE;
    }
    /* --- picture å */
    if ((strcmp(argv[i], "-picture") == 0) ||
	(strcmp(argv[i], "--picture") == 0)) {
      picture_file = malloc(strlen(argv[i+1]) + 1);
      if (picture_file != NULL) {
	strcpy(picture_file, argv[i+1]);
	geometry_flag = TRUE;
	i++;
	rest--;
      }
    }
    i++;
    rest--;
  }
  if (help_flag == TRUE) help_output();
}


/* -------------------------------------------------------------
  RRSwitchGetHelp  -- helpåɤ߼

   return : gboolean ꤵƤ뤫ɤե饰

-------------------------------------------------------------- */
gboolean RRSwitchGetHelp(void)
{
  return(help_flag);
}

/* -------------------------------------------------------------
  RRSwitchGetGeometry  -- geometryɤ߼

   return : gboolean ꤵƤ뤫ɤե饰
   RRSwitchGeometry *  (Ϥ)

-------------------------------------------------------------- */
gboolean RRSwitchGetGeometry(RRSwitchGeometry *win_rect)
{
  win_rect->w = geometry_w;
  win_rect->h = geometry_h;
  win_rect->x = geometry_x;
  win_rect->y = geometry_y;
  return(geometry_flag);
}


/* -------------------------------------------------------------
  RRSwitchGetRoot  -- rootåɤ߼

   return : gboolean ꤵƤ뤫ɤե饰

-------------------------------------------------------------- */
gboolean RRSwitchGetRoot(void)
{
  return(root_flag);
}


/* -------------------------------------------------------------
  RRSwitchGetPicture  -- եåλ

   return : ե̾

-------------------------------------------------------------- */
gchar *RRSwitchGetPicture(void)
{
  return(picture_file);
}


/* -----------------------------------------------------------------------
 --- ̥å
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  help_output  -- ޥɥإפɽ
-------------------------------------------------------------- */
void  help_output(void) {
  printf("--- limo clock\n");
  printf("usage: limo_clock [-h|--help] [-geometry|--geometry position]\n");
  printf("                  [-picture|--picture file]\n");
  printf("\n");
  printf(" h/help       : print this message.\n");
  printf(" geometry     : window position.\n");
  printf(" picture file : use 'file' as background picture.\n");
}

/* -------------------------------------------------------------
  switch_geometry  -- geometry ΥåɤߤȤ
-------------------------------------------------------------- */
void switch_geometry(char *line)
{
  char  *c, num[256];
  int  i, l, mod, p, sign;
  long  n;

  c = line;
  i = l = mod = p = 0;
  sign = 1;
  do {
    if ((c[i] >= '0') && (c[i] <= '9') && (l < 256)) {
      num[l] = c[i];
      l++;
    }
    else {
      num[l] = (char)NULL;
      l = 0;
      n = strtol(num, (char**)NULL, 10);
      switch(mod) {
      case 0:
	geometry_w = (gint)n;
	break;
      case 1:
	geometry_h = (gint)n;
	break;
      case 2:
      case 3:
	if (p == 1) geometry_x = (gint)(n * sign);
	if (p == 2) geometry_y = (gint)(n * sign);
	break;
      }
      if (c[i] == 'x') mod = 1;
      if (c[i] == '+') {
	if (p == 0) {
	  p++;
	  mod = 2;
	}
	else if (p == 1) {
	  p++;
	  mod = 3;
	}
	sign = 1;
      }
      if (c[i] == '-') {
	if (p == 0) {
	  p++;
	  mod = 2;
	}
	else if (p == 1) {
	  p++;
	  mod = 3;
	}
	sign = -1;
      }
    }
  } while(c[i++] != (char)NULL);
}
